<?php
class gateway_paystar extends gatewayCore
{
	public function __construct( ipsRegistry $registry ) 
	{
		parent::__construct($registry);
		require_once(IPSLib::getAppDir('nexus') . '/sources/paystarconfig.php');
		$this->paystar_wsconfig = $ws_config;
	}
    
  	 public $maxAmounts = array(
        'USD'    => '*',
		'IRR'    => '*'
	);
	
	public function payScreen() 
	{
		$res = false;
		$pin = $this->method['m_settings']['pin'];
		if(empty($pin)) 
			return false;	
		
		$amount = $this->transaction['t_amount']; 
		
		$c = $this->invoice->customer->data;
		$description = "شناسه کاربری مشتری : " . $c['member_id'];
		$description .= "\nنام کاربری مشتری : " . $c['name'];
		$description .= "\nایمیل مشتری : " . $c['email'];
		if(!empty($c['cm_phone']))
			$description .= "\nتلفن مشتری : " . $c['cm_phone'];

		try
		{
			$f = array(
				'amount' => $amount/10,
				'pin' => $pin,
				'callback' => ($this->settings['base_url_https']?$this->settings['base_url_https']:$this->settings['base_url']) . "app=nexus&module=payments&section=receive&validate=paystar&nexusinvoice={$this->invoice->__get('id')}&transid={$this->transaction['t_id']}",
				'bank' => $this->paystar_wsconfig['dbank'],
				'description' => $description
			);

			$f_ = '';
			foreach($f as $k=>$v) 
				$f_ .= $k . '=' . urlencode($v) . '&'; 
				
			rtrim($f_, '&');

			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, "https://{$this->paystar_wsconfig['address']}/api/create/");
			curl_setopt($ch,CURLOPT_POST, count($f));
			curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch);
		}
		catch(Exception $e) 
		{
			return false;
		}
		
		if(strlen($res) > 5)
			return array("formUrl"	=> 'https://' . $this->paystar_wsconfig['address'] . '/paying/' . $res);
	    
		return false;
	}

	public function validatePayment()
	{	
		$pin = $this->method['m_settings']['pin'];
		if(empty($pin)) 
			return false;

		$amount = $this->transaction['t_amount'];
		$au = !empty($_POST['transid']) ? $_POST['transid'] : 0;
		
		$res = false;
		try
		{
			$f = array(
				'amount' => $amount/10,
				'pin' => $pin,
				'transid' => $au,
			);
			
			$f_ = '';
			foreach($f as $k=>$v) 
				$f_ .= $k . '=' . urlencode($v) . '&'; 
				
			rtrim($f_, '&');

			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, "https://{$this->paystar_wsconfig['address']}/api/verify/");
			curl_setopt($ch,CURLOPT_POST, count($f));
			curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
			curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch);
		}
		catch(Exception $e) 
		{
			return false;
		}

		if(!empty($res) AND $res == 1)
			return array( 'status' => "okay", 'amount' => $amount, 'gw_id' => $au);	
			
		return false;
	}
}